# Turbo TUSMO

Programme pour résolution de Tusmo.

## Usage

### Dépendances

- deno
    - windows `winget install --id=DenoLand.Deno -e`
    - ubuntu / debian `sudo snap install deno`
    - archlinux `sudo pacman -S deno`

### Simulation

```sh
./src/simulation.ts -h
# Usage: simulation
# 
# Description:
# 
#   Program to simulate TUSMO game with guesser controller.
# 
# Options:
# 
#   -h, --help              - Show this help.                                                                     
#   -f, --file    <path>    - Sets dictionnary to use words from (defaults to internal french dict).              
#   -n, --length  <length>  - Length of the word to use from the dictionnary.                         (Default: 6)
#   -w, --wait    <wait>    - Time to wait between guesses, in ms.                                    (Default: 0)
```

### Proxy

```sh
./src/manual_proxy.ts
# Please input initial state of the game. Format is :
#   letter    [a-z]    known letter
#   dot       .        unknown letter
# example : .rb..

# initial : a....

# From now on, please try the following guesses and report results. Format is :
#   plus     +    correct
#   minus    -    wrong placement
#   dot      .    incorrect
# example : -++..

# <proxy> Guessing: aires
# <proxy>   Result: +.--.

#    Knows: .....
# Guessing: aires
#      Got: #.**.

# <proxy> Guessing: acere
# <proxy>   Result: +..++

#    Knows: a....
# Guessing: acere
#      Got: #..##

# <proxy> Guessing: arabe
# <proxy>   Result: ++.-+

#    Knows: a..re
# Guessing: arabe
#      Got: ##.*#

# <proxy> Guessing: aveux
# <proxy>   Result: +.-..

#    Knows: ar.re
# Guessing: aveux
#      Got: #.*..

# <proxy> Guessing: album
# <proxy>   Result: +.+..

#    Knows: ar.re
# Guessing: album
#      Got: #.#..

# <proxy> Guessing: arbre
# <proxy>   Result: +++++

#    Knows: arbre
# Guessing: arbre
#      Got: success

# Stopped on arbre .
# With success .
# In 6 steps
```
